diff --git a/wcs/admin/forms.py b/wcs/admin/forms.py
index e121b8b..f2d4bda 100644
--- a/wcs/admin/forms.py
+++ b/wcs/admin/forms.py
@@ -206,7 +206,7 @@ class WorkflowRoleDirectory(Directory):
 
 class FormDefPage(Directory):
     _q_exports = ['', 'fields', 'delete', 'duplicate', 'export',
-                  'invite', 'enable', 'workflow', 'category',
+                  'anonymise', 'invite', 'enable', 'workflow', 'category',
                   'role', ('workflow-options', 'workflow_options'),
                   ('workflow-status-remapping', 'workflow_status_remapping'),
                   'roles', 'title', 'options', ('acl-read', 'acl_read')]
@@ -381,6 +381,7 @@ class FormDefPage(Directory):
         r += htmltext('<li><a href="duplicate">%s</a></li>') % _('Duplicate')
         if ET:
             r += htmltext('<li><a href="export">%s</a></li>') % _('Export')
+        r += htmltext('<li><a href="anonymise">%s</a></li>') % _('Anonymise handled forms')
         if self.formdef.roles:
             r += htmltext('<li><a href="invite">%s</a></li>') % _('Invites')
         r += htmltext('</ul>')
@@ -711,6 +712,84 @@ class FormDefPage(Directory):
                 'attachment; filename=%s.wcs' % self.formdef.url_name)
         return '<?xml version="1.0" encoding="iso-8859-15"?>\n' + ET.tostring(x)
 
+    def anonymise(self):
+        if get_request().form.get('job'):
+            return self.anonymise_processing()
+
+        form = Form(enctype='multipart/form-data')
+
+        form.widgets.append(HtmlWidget('<p>%s</p>' % _(
+            "You are about to irrevocably anonymise forms which are closed.")))
+        form.add_submit('submit', _('Submit'))
+        form.add_submit('cancel', _('Cancel'))
+
+        if form.get_widget('cancel').parse():
+            return redirect('.')
+
+        if not form.is_submitted() or form.has_errors():
+            get_response().breadcrumb.append(('anonymise', _('Anonymise')))
+            html_top('forms', title = _('Anonymise Forms'))
+            r = TemplateIO(html=True)
+            r += htmltext('<h2>%s</h2>') % _('Anonymise Forms')
+            r += form.render()
+            return r.getvalue()
+        else:
+            return self.anonymise_submit(form)
+
+    def anonymise_submit(self, form):
+
+        class Anonymiser:
+
+            def __init__(self, formdef):
+                self.formdef = formdef
+
+            def anonymise(self, job=None):
+                all_forms = self.formdef.data_class().select()
+                not_endpoint_status = self.formdef.workflow.get_not_endpoint_status()
+                not_endpoint_status_ids = ['wf-%s' % x.id for x in not_endpoint_status]
+                all_forms = [x for x in all_forms if x.status not in not_endpoint_status_ids]
+                for formdata in all_forms:
+                    if not formdata.anonymised:
+                        formdata.anonymise()
+
+        count = self.formdef.data_class().count()
+        anonymiser = Anonymiser(self.formdef)
+        if count > 100: # Arbitrary threshold
+            job = get_response().add_after_job(
+                str(N_('Anonymising forms')),
+                anonymiser.anonymise)
+            return redirect('anonymise?job=%s' % job.id)
+        else:
+            anonymiser.anonymise()
+
+        return redirect('.')
+
+    def anonymise_processing(self):
+        try:
+            job = AfterJob.get(get_request().form.get('job'))
+        except KeyError:
+            return redirect('.')
+
+        html_top('forms', title=_('Anonymising'))
+        r = TemplateIO(html=True)
+        r += get_session().display_message()
+        get_response().add_javascript(['jquery.js', 'afterjob.js'])
+        r += htmltext('<dl class="job-status">')
+        r += htmltext('<dt>')
+        r += _(job.label)
+        r += htmltext('</dt>')
+        r += htmltext('<dd>')
+        r += htmltext('<span class="afterjob" id="%s">') % job.id
+        r += _(job.status)
+        r += htmltext('</span>')
+        r += htmltext('</dd>')
+        r += htmltext('</dl>')
+
+        r += htmltext('<div class="done">')
+        r += htmltext('<a href="./">%s</a>') % _('Back')
+        r += htmltext('</div>')
+        return r.getvalue()
+
     def invite(self):
         if not self.formdef.roles:
             return template.error_page(
diff --git a/wcs/fields.py b/wcs/fields.py
index 1ff779f..4e7ed8f 100644
--- a/wcs/fields.py
+++ b/wcs/fields.py
@@ -115,6 +115,7 @@ class Field:
     prefill = None
     store_display_value = None
 
+    anonymise = True
     stats = None
 
     def __init__(self, **kwargs):
@@ -547,6 +548,7 @@ class BoolField(WidgetField):
 
     widget_class = CheckboxWidget
     required = False
+    anonymise = False
 
     def perform_more_widget_changes(self, form, kwargs, edit = True):
         if not edit:
@@ -626,6 +628,7 @@ class FileField(WidgetField):
     key = 'file'
     description = N_('File Upload')
 
+    anonymise = False
     widget_class = FileWithPreviewWidget
 
     def get_view_value(self, value):
@@ -757,6 +760,7 @@ class ItemField(WidgetField):
 
     items = []
     show_as_radio = False
+    anonymise = False
     widget_class = SingleSelectHintWidget
     data_source = {}
 
@@ -891,6 +895,7 @@ class ItemsField(WidgetField):
 
     items = []
     max_choices = 0
+    anonymise = False
 
     widget_class = CheckboxesWidget
 
@@ -1309,6 +1314,7 @@ class RankedItemsField(WidgetField):
     items = []
     randomize_items = False
     widget_class = RankedItemsWidget
+    anonymise = False
 
     def perform_more_widget_changes(self, form, kwargs, edit = True):
         kwargs['elements'] = self.items or []
diff --git a/wcs/formdata.py b/wcs/formdata.py
index 069f1f0..7565700 100644
--- a/wcs/formdata.py
+++ b/wcs/formdata.py
@@ -130,6 +130,7 @@ class FormData(StorableObject):
     user_hash = None
     receipt_time = None
     status = None
+    anonymised = None
     page_no = None # page to use when restoring from draft
     evolution = None
     data = None
@@ -438,6 +439,26 @@ class FormData(StorableObject):
 
         return status_action_roles
 
+    def anonymise(self):
+        for field in self.formdef.fields:
+            if field.anonymise:
+                self.data[field.id] = None
+
+        self.anonymised = time.localtime()
+        self.user_id = None
+        self.user_hash = None
+        self.editable_by = None
+        self._signature = None
+        self.workflow_data = None
+        self.workflow_roles = None
+
+        for evo in self.evolution:
+            evo.who = None
+            evo.parts = None
+            evo.comment = None
+            evo.parts = None
+        self.store()
+
     def export_to_json(self):
         data = {}
         data['id'] = '%s/%s' % (self.formdef.url_name, self.id)
diff --git a/wcs/sql.py b/wcs/sql.py
index 72ffd19..81f95fd 100644
--- a/wcs/sql.py
+++ b/wcs/sql.py
@@ -112,6 +112,7 @@ def do_formdef_tables(formdef):
                                     user_id varchar,
                                     user_hash varchar,
                                     receipt_time timestamp,
+                                    anonymised timestamp,
                                     status varchar,
                                     page_no varchar,
                                     workflow_data bytea,
@@ -131,7 +132,7 @@ def do_formdef_tables(formdef):
 
     needed_fields = set(['id', 'user_id', 'user_hash', 'receipt_time',
         'status', 'workflow_data', 'id_display', 'fts', 'page_no',
-        'workflow_roles', 'workflow_roles_array'])
+        'anonymised', 'workflow_roles', 'workflow_roles_array'])
 
     # migrations
     if not 'fts' in existing_fields:
@@ -147,6 +148,9 @@ def do_formdef_tables(formdef):
     if not 'page_no' in existing_fields:
         cur.execute('''ALTER TABLE %s ADD COLUMN page_no varchar''' % table_name)
 
+    if not 'anonymised' in existing_fields:
+        cur.execute('''ALTER TABLE %s ADD COLUMN anonymised timestamp''' % table_name)
+
     # add new fields
     for field in formdef.fields:
         assert field.id is not None
@@ -449,6 +453,7 @@ class SqlFormData(SqlMixin, wcs.formdata.FormData):
         ('receipt_time', 'timestamp'),
         ('status', 'varchar'),
         ('page_no', 'varchar'),
+        ('anonymised', 'timestamp'),
         ('workflow_data', 'bytea'),
         ('id_display', 'varchar'),
         ('workflow_roles', 'bytea'),
@@ -506,11 +511,18 @@ class SqlFormData(SqlMixin, wcs.formdata.FormData):
                 'page_no': self.page_no,
                 'workflow_data': bytearray(cPickle.dumps(self.workflow_data)),
                 'id_display': self.id_display,
+                'anonymised': self.anonymised,
         }
         if self.receipt_time:
             sql_dict['receipt_time'] = datetime.datetime.fromtimestamp(time.mktime(self.receipt_time)),
         else:
             sql_dict['receipt_time'] = None
+
+        if self.anonymised:
+            sql_dict['anonymised'] = datetime.datetime.fromtimestamp(time.mktime(self.anonymised)),
+        else:
+            sql_dict['anonymised'] = None
+
         if self.workflow_roles:
             sql_dict['workflow_roles'] = bytearray(cPickle.dumps(self.workflow_roles))
             sql_dict['workflow_roles_array'] = [int(x) for x in self.workflow_roles.values()]