diff --git a/wcs/admin/forms.py b/wcs/admin/forms.py
index 3463647..10b34d0 100644
--- a/wcs/admin/forms.py
+++ b/wcs/admin/forms.py
@@ -206,7 +206,7 @@ class WorkflowRoleDirectory(Directory):
 
 class FormDefPage(Directory):
     _q_exports = ['', 'fields', 'delete', 'duplicate', 'export',
-                  'archive', 'invite', 'enable', 'workflow', 'category',
+                  'invite', 'enable', 'workflow', 'category',
                   'role', ('workflow-options', 'workflow_options'),
                   ('workflow-status-remapping', 'workflow_status_remapping'),
                   'roles', 'title', 'options', ('acl-read', 'acl_read')]
@@ -386,8 +386,6 @@ class FormDefPage(Directory):
         r += htmltext('<li><a href="duplicate">%s</a></li>') % _('Duplicate')
         if ET:
             r += htmltext('<li><a href="export">%s</a></li>') % _('Export')
-        if not (get_publisher().has_site_option('postgresql') and get_cfg('postgresql', {})):
-            r += htmltext('<li><a href="archive">%s</a></li>') % _('Archive')
         if self.formdef.roles:
             r += htmltext('<li><a href="invite">%s</a></li>') % _('Invites')
         r += htmltext('</ul>')
@@ -723,130 +721,6 @@ class FormDefPage(Directory):
                 'attachment; filename=%s.wcs' % self.formdef.url_name)
         return '<?xml version="1.0" encoding="iso-8859-15"?>\n' + ET.tostring(x)
 
-    def archive(self):
-        if get_publisher().has_site_option('postgresql') and get_cfg('postgresql', {}):
-            raise TraversalError()
-
-        if get_request().form.get('job'):
-            return self.archive_processing()
-        if get_request().form.get('download'):
-            return self.archive_download()
-
-        form = Form(enctype='multipart/form-data')
-
-        form.add(DateWidget, 'date', title = _('Archive forms handled before'))
-        form.add(CheckboxWidget, 'not-done', title = _('Include forms that have not been handled'),
-                value = False)
-        form.add(CheckboxWidget, 'keep', title = _('Do not remove forms'),
-                value = False)
-        form.add_submit('submit', _('Submit'))
-        form.add_submit('cancel', _('Cancel'))
-
-        if form.get_widget('cancel').parse():
-            return redirect('.')
-
-        if not form.is_submitted() or form.has_errors():
-            get_response().breadcrumb.append(('archive', _('Archive')))
-            self.html_top(title = _('Archive Forms'))
-            r = TemplateIO(html=True)
-            r += htmltext('<h2>%s</h2>') % _('Archive Forms')
-            r += form.render()
-            return r.getvalue()
-        else:
-            return self.archive_submit(form)
-
-    def archive_submit(self, form):
-
-        class Archiver:
-            def __init__(self, formdef):
-                self.formdef = formdef
-
-            def archive(self, job=None):
-                all_forms = self.formdef.data_class().select()
-
-                if form.get_widget('not-done').parse() is False:
-                    not_endpoint_status = self.formdef.workflow.get_not_endpoint_status()
-                    not_endpoint_status_ids = ['wf-%s' % x.id for x in not_endpoint_status]
-                    all_forms = [x for x in all_forms if x.status not in not_endpoint_status_ids]
-
-                if form.get_widget('date').parse():
-                    date = form.get_widget('date').parse()
-                    date = time.strptime(date, misc.date_format())
-                    all_forms = [x for x in all_forms if (
-                        x.evolution and x.evolution[-1].time < date) or (
-                        x.receipt_time < date)]
-
-                self.fd = StringIO()
-                t = tarfile.open('wcs.tar.gz', 'w:gz', fileobj=self.fd)
-                t.add(self.formdef.get_object_filename(), 'formdef')
-                for formdata in all_forms:
-                    t.add(formdata.get_object_filename(), '%s/%s' % (self.formdef.url_name, str(formdata.id)))
-                t.close()
-
-                if form.get_widget('keep').parse() is False:
-                    for f in all_forms:
-                        f.remove_self()
-
-                if job:
-                    job.file_content = self.fd.getvalue()
-                    job.store()
-
-        count = self.formdef.data_class().count()
-        archiver = Archiver(self.formdef)
-        if count > 100: # Arbitrary threshold
-            job = get_response().add_after_job(
-                str(N_('Archiving forms')),
-                archiver.archive)
-            return redirect('archive?job=%s' % job.id)
-        else:
-            archiver.archive()
-
-            response = get_response()
-            response.set_content_type('application/x-wcs-archive')
-            response.set_header('content-disposition',
-                'attachment; filename=%s-archive.wcs' % self.formdef.url_name)
-            return archiver.fd.getvalue()
-
-    def archive_processing(self):
-        try:
-            job = AfterJob.get(get_request().form.get('job'))
-        except KeyError:
-            return redirect('.')
-
-        self.html_top(title=_('Archiving'))
-        r = TemplateIO(html=True)
-        r += get_session().display_message()
-        get_response().add_javascript(['jquery.js', 'afterjob.js'])
-        r += htmltext('<dl class="job-status">')
-        r += htmltext('<dt>')
-        r += _(job.label)
-        r += htmltext('</dt>')
-        r += htmltext('<dd>')
-        r += htmltext('<span class="afterjob" id="%s">') % job.id
-        r += _(job.status)
-        r += htmltext('</span>')
-        r += htmltext('</dd>')
-        r += htmltext('</dl>')
-
-        r += htmltext('<div class="done">')
-        r += htmltext('<a href="archive?download=%s">%s</a>') % (job.id, _('Download Archive'))
-        r += htmltext('</div>')
-        return r.getvalue()
-
-    def archive_download(self):
-        try:
-            job = AfterJob.get(get_request().form.get('download'))
-        except KeyError:
-            return redirect('.')
-
-        if not job.status == 'completed':
-            raise TraversalError()
-        response = get_response()
-        response.set_content_type('application/x-wcs-archive')
-        response.set_header('content-disposition',
-            'attachment; filename=%s-archive.wcs' % self.formdef.url_name)
-        return job.file_content
-
     def invite(self):
         if not self.formdef.roles:
             return template.error_page(